package easydo.technology.controller;

import easydo.technology.components.JdbcClient;
import easydo.technology.enums.MESEnum;
import easydo.technology.exception.BizException;
import easydo.technology.model.ProcessStage;
import easydo.technology.service.FlowNoService;
import easydo.technology.utils.SecurityUtils;
import easydo.technology.utils.StringUtil;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.sql.DataSource;
import java.sql.Connection;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/processManage")
public class ProcessStageController {
    @Resource
    JdbcClient jdbcClient;
    @Resource
    DataSource dataSource;
    @Resource
    FlowNoService flowNoService;

    @RequestMapping(value = "/getList")
    public Object getList(@RequestBody Map<String, Object> map) throws Exception {
        List<ProcessStage> list = jdbcClient.getJdbcList(map, ProcessStage.class);
        return new ResponseEntity<>(list, HttpStatus.OK);
    }

    @RequestMapping(value = "/getPage")
    public Object getPage(@RequestBody Map<String, Object> map) throws Exception {
        Connection connection = dataSource.getConnection();
        try {
            Map<String, Object> recordsPage = jdbcClient.getJdbcPage(map, ProcessStage.class, connection);
            List<ProcessStage> records = (List<ProcessStage>) recordsPage.get("records");
            for (ProcessStage model : records) {
                jdbcClient.getMinioFile(model, connection);
            }
            return new ResponseEntity<>(recordsPage, HttpStatus.OK);
        } catch (Exception e) {
            throw new BizException(e.getMessage());
        } finally {
            connection.close();
        }
    }


    @RequestMapping(value = "/save")
    public Object add(@RequestBody ProcessStage model) throws Exception {
        Connection connection = dataSource.getConnection();
        try {
            connection.setAutoCommit(false);
            model.setStatus(MESEnum.PROCESS_OF_STATUS_ENABLE.getValue());
            model.setCreateId(SecurityUtils.getCurrentUserId());
            generateCode(model, connection);
            jdbcClient.jdbcInsert(model, connection);
            connection.commit();
            return new ResponseEntity<>(model, HttpStatus.OK);
        } catch (Exception e) {
            connection.rollback();
            throw new BizException(e.getMessage());
        } finally {
            connection.close();
        }
    }


    @RequestMapping(value = "/update")
    public Object update(@RequestBody ProcessStage model) throws Exception {
        jdbcClient.jdbcUpdateById(model);
        return new ResponseEntity<>(HttpStatus.OK);
    }

    @RequestMapping(value = "/remove")
    public Object deleteProgram(@RequestBody ProcessStage model) throws Exception {
        jdbcClient.jdbcRemoveById(model);
        return new ResponseEntity<>(HttpStatus.OK);
    }

    private synchronized void generateCode(ProcessStage model, Connection connection) throws Exception {
        if (StringUtil.isEmpty(model.getCode())) {
            while (true) {
                String flowNo = flowNoService.getFlowNo(MESEnum.FLOW_NO_TYPE_PROCESS_STAGE.getValue(), connection);
                ProcessStage processStageParam = new ProcessStage();
                processStageParam.setCode(flowNo);
                int count = jdbcClient.getJdbcCount(processStageParam, connection);
                if (count == 0) {
                    model.setCode(flowNo);
                    break;
                }
            }
        } else {
            ProcessStage processStageParam = new ProcessStage();
            processStageParam.setCode(model.getCode());
            int count = jdbcClient.getJdbcCount(processStageParam, connection);
            if (count > 0) {
                throw new BizException("编号已存在，请重新填写");
            }
        }
    }
}
